#include <windows.h>
#include <stdio.h>
#include <string.h>

#define DATALEN 512

#define DEV_PREFIX      L"\\\\.\\"
#define DEV_MBR_PREFIX  L"\\\\.\\PhysicalDrive"

main ()
{
    WCHAR* CmdLineW;
    PWCHAR* argv;
    int argc;
    WCHAR* Path;
    HANDLE h;
    char* buf;
    DWORD dw ;
    ULONG n;

    CmdLineW = GetCommandLineW();
    argv = CommandLineToArgvW(CmdLineW, &argc);

    if(argc < 2) {
        printf("Boot-sector and MBR read utility v1.1 (c) by Alter, 2006,2009\n"
               "Home site http://www.alter.org.ua\n");
        printf("Usage:\n"
               "  read_boot <DriveLetter>: <TargetFile>\n"
               "    will store boot-sector in file\n"
               "  read_boot <DriveLetter>:\n"
               "    will dump boot-sector to STDOUT\n"
               "  read_boot mbr<Number>: <TargetFile>\n"
               "    will store MBR in file\n"
               "  read_boot mbr<Number>:\n"
               "    will dump MBR to STDOUT\n"
               );
        return -1;
    }

    if(!_wcsnicmp(argv[1], L"mbr", 3)) {
        Path = (PWCHAR)GlobalAlloc(GMEM_FIXED, wcslen(argv[1])*sizeof(WCHAR) + sizeof(DEV_MBR_PREFIX));
        n = swprintf(Path, DEV_MBR_PREFIX L"%s", argv[1]+3);
        if(n) {
            Path[n-1] = 0;
        }
    } else {
        Path = (PWCHAR)GlobalAlloc(GMEM_FIXED, wcslen(argv[1])*sizeof(WCHAR) + sizeof(DEV_PREFIX));
        swprintf(Path, DEV_PREFIX L"%s", argv[1]);
    }

    buf = (PCHAR)GlobalAlloc(GMEM_FIXED, DATALEN);

    h = CreateFileW (Path, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, NULL) ;
    if(!h || h == (HANDLE)(-1)) {
        printf("Can't open %S\n", Path);
        printf("Error %d\n", GetLastError());
        return -2;
    }

    ReadFile (h, buf, DATALEN, &dw, 0);
    CloseHandle(h);

    if(dw != DATALEN) {
        printf("Read %d bytes instead of %d\n", dw, DATALEN);
        printf("Error %d\n", GetLastError());
        return -2;
    }

    if(argc == 2) {
        h = GetStdHandle (STD_OUTPUT_HANDLE);
        if(!h || h == (HANDLE)(-1)) {
            printf("Can't access STDOUT\n");
            printf("Error %d\n", GetLastError());
            return -2;
        }
    } else {
        h = CreateFileW (argv[2], GENERIC_WRITE, 0, 0, CREATE_NEW, 0, NULL) ;
        if(!h || h == (HANDLE)(-1)) {
            printf("Can't create output file %S\n", argv[2]);
            printf("Error %d\n", GetLastError());
            return -2;
        }
    }
    WriteFile (h, buf, DATALEN, &dw, 0);
    if(dw != DATALEN) {
        printf("Written %d bytes instead of %d\n", dw, DATALEN);
        printf("Error %d\n", GetLastError());
        return -2;
    }
    CloseHandle(h);
}
